VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1320
   ClientLeft      =   2010
   ClientTop       =   1860
   ClientWidth     =   5850
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1320
   ScaleWidth      =   5850
   Begin VB.CommandButton Command1 
      Caption         =   "Copy"
      Default         =   -1  'True
      Height          =   375
      Left            =   2520
      TabIndex        =   4
      Top             =   840
      Width           =   735
   End
   Begin VB.TextBox txtTo 
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Top             =   480
      Width           =   4575
   End
   Begin VB.TextBox txtFrom 
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Top             =   120
      Width           =   4575
   End
   Begin VB.Label Label2 
      Caption         =   "To file"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "From file"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MAX_PATH = 260
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long

Private Const ERROR_NO_MORE_FILES = 18&
Private Const INVALID_HANDLE_VALUE = -1
Private Const DDL_DIRECTORY = &H10
' Copy all files below this directory. Return the
' number of files copied.
Private Function CopyFiles(ByVal from_dir As String, ByVal to_dir As String) As Long
Dim files_copied As Long
Dim dirs As Collection
Dim fname As String
Dim search_handle As Long
Dim file_data As WIN32_FIND_DATA
Dim i As Integer

    Set dirs = New Collection

    ' Get the first file.
    search_handle = FindFirstFile( _
        from_dir & "*.*", file_data)
    If search_handle <> INVALID_HANDLE_VALUE Then
        ' Get the rest of the files.
        Do
            ' Get the file name.
            fname = file_data.cFileName
            fname = Left$(fname, InStr(fname, Chr$(0)) - 1)

            ' Skip the files "." and "..".
            If fname <> "." And fname <> ".." Then
                files_copied = files_copied + 1

                ' See if the file is a directory.
                If file_data.dwFileAttributes And DDL_DIRECTORY Then
                    ' This is a directory.
                    ' Make the new directory.
                    MkDir to_dir & fname

                    ' Save the directory name so
                    ' we can search it later.
                    dirs.Add fname
                Else
                    ' This is not a directory.
                    ' Copy the file.
                    FileCopy from_dir & fname, to_dir & fname
                End If
            End If

            ' Get the next file.
            If FindNextFile(search_handle, file_data) = 0 Then Exit Do
        Loop

        ' Close the file search hanlde.
        FindClose search_handle
    End If

    ' Search subdirectories.
    For i = 1 To dirs.Count
        fname = dirs(i)
        files_copied = files_copied + CopyFiles(from_dir & fname & "\", to_dir & fname & "\")
    Next i

    CopyFiles = files_copied
End Function
' Copy from_file to to_file. If from_file is a
' directory, copy it and its files, creating to_file
' if necessary.
Private Function XCopyFile(ByVal from_file As String, ByVal to_file As String) As Long
Dim files_copied As Long

    ' See if from_file is a directory.
    If GetAttr(from_file) And vbDirectory Then
        ' This is a directory.
        If Right$(from_file, 1) <> "\" Then from_file = from_file & "\"
        If Right$(to_file, 1) <> "\" Then to_file = to_file & "\"

        ' Create to_file if necessary.
        On Error Resume Next
        MkDir to_file
        If Err.Number = 0 Then files_copied = 1
        On Error GoTo 0

        ' Copy the files in the directory.
        files_copied = files_copied + CopyFiles(from_file, to_file)
    Else
        ' This is not a directory.
        ' Copy the file.
        FileCopy from_file, to_file

        files_copied = 1
    End If

    XCopyFile = files_copied
End Function

Private Sub Command1_Click()
Dim from_file As String
Dim to_file As String
Dim files_copied As Long

    MousePointer = vbHourglass
    DoEvents

    from_file = txtFrom.Text
    If Right$(from_file, 1) <> "\" Then from_file = from_file & "\"
    to_file = txtTo.Text
    If Right$(to_file, 1) <> "\" Then to_file = to_file & "\"

    files_copied = XCopyFile(from_file, to_file)

    MousePointer = vbDefault
    MsgBox "Copied " & Format$(files_copied) & " files."
End Sub

Private Sub Form_Load()
    txtFrom.Text = App.Path
    txtTo.Text = "C:\"
End Sub
